RestartGameDialog = {
	CANCEL = 0,
	SAVE = 1,
	NO_SAVE = 2
}

local RestartGameDialog_mt = Class(RestartGameDialog, MessageDialog)

function RestartGameDialog:new(target, custom_mt)
	local self = MessageDialog:new(target, custom_mt or RestartGameDialog_mt)

	self.isBackAllowed = true
	self.inputDelay = 250

	return self
end

function RestartGameDialog:onOpen()
	RestartGameDialog:superClass().onOpen(self)

	self.inputDelay = self.time + 250
end

function RestartGameDialog:onClickBack(forceBack, usedMenuButton)
	self:sendCallback(RestartGameDialog.CANCEL)

	return false
end

function RestartGameDialog:onClickOk()
	self:sendCallback(RestartGameDialog.SAVE)

	return false
end

function RestartGameDialog:onClickCancel()
	self:sendCallback(RestartGameDialog.NO_SAVE)

	return false
end

function RestartGameDialog:sendCallback(value)
	if self.inputDelay < self.time then
		self:close()

		if self.callbackFunc ~= nil then
			if self.target ~= nil then
				self.callbackFunc(self.target, value)
			else
				self.callbackFunc(value)
			end
		end
	end
end

function RestartGameDialog:setCallback(callbackFunc, target)
	self.callbackFunc = callbackFunc
	self.target = target
end